/*
 * appt.c 
 *
 * This function translates the .month data base into  one  that is compatable
 * with the "appt" program. 
 */

/*
 * Modification History 
 *
 * Origional Author:  Robert Dextor@Tektronics[robertd@tekigm2] Modifications by: 
 * Marc Ries@TRW[trwrb!ries] 
 *
 */

#include <curses.h>
#include "month.h"

extern short    calflag, month, this_day, this_month, this_year;

char           *m_names[] = {
			     "jan",
			     "feb",
			     "mar",
			     "apr",
			     "may",
			     "jun",
			     "jul",
			     "aug",
			     "sep",
			     "oct",
			     "nov",
			     "dec"
};

char           *day_names[] = {
			       "sun",
			       "mon",
			       "tue",
			       "wed",
			       "thu",
			       "fri",
			       "sat"
};


display_appt(event)
	struct event_rec *event;
{


	if (has_smtwtfs(event->smtwtfs))
		pr_day_format(event);
	else
		pr_date_format(event);

}
pr_day_format(event)
	struct event_rec *event;
{
int             i;

	for (i = 0; i < 7; i++)
		if (event->smtwtfs[i])
			if (event->monthly)
				pr_reps(event, i);
			else
				pr_date_format(event);
}

pr_reps(event, day)
	struct event_rec *event;
	int             day;
{
int             i;

	for (i = this_month; i < 12; i++)
	{
		(void) printf("%s\t", day_names[day]);
		pr_time(event);
		if (event->last)
			(void) printf("[%s,last]\t", m_names[i]);
		else
			(void) printf("[%s,%d]\t", m_names[i], event->nth);
		pr_event(event);
	}
}

pr_time(event)
	struct event_rec *event;
{

short           stime, etime, hours, minutes, carry;
	stime = event->hour * 100 + event->minute;
	if (stime > 0)
	{
		if (calflag)
		{
			(void) printf("\t%02d:%02d", event->hour, event->minute);
		} else
		{
			(void) printf("<%04d", stime);
			etime = event->span_hours * 100 + event->span_minutes;
			if (etime > 0)
			{
				minutes = (event->minute + event->span_minutes) % 60;
				carry = (event->minute + event->span_minutes) / 60;
				hours = (event->hour + event->span_hours + carry) * 100;
				etime = hours + minutes;
				(void) printf("-%04d", etime);
			}
			(void) printf(">\t");
		}
	}
	if (calflag)
		(void) printf("\n");
}
pr_event(event)
	struct event_rec *event;
{
	if (calflag)
		(void) printf("\t%s", event->event_string);
	else
		(void) printf("\t;%s\n", event->event_string);
}

pr_date_format(event)
	struct event_rec *event;
{

	if (calflag)
	{
		(void) printf("%s %02d ",
		       m_names[event->event_month - 1], event->event_day);
	} else
	{
		(void) printf("%d/%d\t", event->event_month, event->event_day);
	}
	if (!calflag)
		pr_time(event);
	if (event->every)
	{
		if (!calflag)
			(void) printf("[%d] ", event->nth * 7);
	}
	pr_event(event);
	if (calflag)
		pr_time(event);
}
